Index: core/gui_debug.c
===================================================================
--- core/gui_debug.c	(Revision 727)
+++ core/gui_debug.c	(Arbeitskopie)
@@ -12,9 +12,11 @@
 static void *addr;
 static char debug_to_draw;
 static char debug_cont_update;
+static char debug_auto_update;
 static char buf[32];
 static long dummy=0;
 static unsigned int step;
+static unsigned int step_pos;
 
 //-------------------------------------------------------------------
 #define SCREEN_COLOR            0xF7
@@ -24,47 +26,90 @@
     addr = st_addr;
     debug_to_draw = 1;
     debug_cont_update = 1;
+    debug_auto_update = 1;
     step = 4;
+    step_pos = 0;
     gui_set_mode(GUI_MODE_DEBUG);
 }
 
+// just a quick hack, a real memory layout manager would be cool
+int address_safe( void* addr, int len )
+{
+    char* pa = addr;
+    if (!(addr < (void*)0x2000000 || addr > (void*)0xFFC00000))
+    { // in a bad zone...
+	return 0;
+    }
+    if( len && !address_safe(pa+len,0 ) )
+    {
+	return 0;
+    }
+    return 1;
+}
 //-------------------------------------------------------------------
-static void gui_debug_draw_values(const coord y, void* addr) {
+static void gui_debug_draw_values(const coord y, char* addr) {
     int i;
+    int col = COLOR_WHITE;
 
-    if (!(addr<(void*)0x2000000 || addr>(void*)0xFFC00000)) { addr = &dummy; };
+    if( ! debug_auto_update )
+    {
+	return;
+    }
+    if (!address_safe(addr,0))
+    {
+        addr = (char*)&dummy; 
+	col = COLOR_RED;
+    }
 
     sprintf(buf, "0x%08X (%10u)", *((unsigned int*)addr), *((unsigned int*)addr));
-    draw_txt_string(10, y, buf, MAKE_COLOR(COLOR_BLACK, COLOR_WHITE));
+    draw_txt_string(10, y, buf, MAKE_COLOR(COLOR_BLACK, col));
 
+
     sprintf(buf, "0x%04X (%5hu)", *((unsigned short*)addr), *((unsigned short*)addr));
-    draw_txt_string(10, y+1, buf, MAKE_COLOR(COLOR_BLACK, COLOR_WHITE));
+    draw_txt_string(10, y+1, buf, MAKE_COLOR(COLOR_BLACK, col));
 
-    sprintf(buf, "0x%02X (%3hu)", *((unsigned char*)addr), *((unsigned char*)addr));
-    draw_txt_string(10, y+2, buf, MAKE_COLOR(COLOR_BLACK, COLOR_WHITE));
+    sprintf(buf, "0x%04X (%5hu)", *((unsigned short*)(addr+2)), *((unsigned short*)(addr+2)));
+    draw_txt_string(25, y+1, buf, MAKE_COLOR(COLOR_BLACK, col));
 
-//    sprintf(buf, "0x%lf", *((double*)addr));
-//    draw_txt_string(10, y+3, buf, MAKE_COLOR(COLOR_BLACK, COLOR_WHITE));
 
-    for (i=0; i<30; ++i) {
-        if (*((char*)(addr+i))) buf[i]=*((char*)(addr+i));
-        else break;
+    for(i=0; i < 4; ++i )
+    {
+	sprintf(buf, "x%02X(%3hu)", *((unsigned char*)(addr+i)), *((unsigned char*)(addr+i)));
+	draw_txt_string(10 + i*8, y+2, buf, MAKE_COLOR(COLOR_BLACK, col));
     }
-    while (i<30) {
-        buf[i++]=' ';
+
+#ifdef DEBUG_SHOW_DOUBLE
+    if( address_safe(addr,sizeof(double) ) )
+    {
+	sprintf(buf, "%f", *((double*)addr));
+	draw_txt_string(10, y+3, buf, MAKE_COLOR(COLOR_BLACK, col));
     }
-    buf[i]=0;
-    draw_txt_string(10, y+4, buf, MAKE_COLOR(COLOR_BLACK, COLOR_WHITE));
+#endif
+
+    for (i=0; i<31; ++i) {
+        if ( addr[i])
+	{
+	    buf[i] = addr[i];
+	}
+	else
+	{
+	    buf[i] = '.';
+	}
+    }
+    buf[31]=0;
+    draw_txt_string(10, y+4, buf, MAKE_COLOR(COLOR_BLACK, col));
 }
 
 //-------------------------------------------------------------------
 void gui_debug_draw() {
+    unsigned sinv = 9 - step_pos;
     switch (debug_to_draw) {
         case 1:
             draw_filled_rect(0, 0, screen_width-1, screen_height-1, MAKE_COLOR(SCREEN_COLOR, SCREEN_COLOR));
             draw_txt_string(1, 0, "Address:", MAKE_COLOR(SCREEN_COLOR, COLOR_WHITE));
-            draw_txt_string(22, 0, "Incr:", MAKE_COLOR(SCREEN_COLOR, COLOR_WHITE));
-            draw_txt_string(39,0,  "Auto:", MAKE_COLOR(SCREEN_COLOR, COLOR_WHITE));
+            draw_txt_string(21, 0, "Incr:", MAKE_COLOR(SCREEN_COLOR, COLOR_WHITE));
+            draw_txt_string(38,0,  "A:", MAKE_COLOR(SCREEN_COLOR, COLOR_WHITE));
+            draw_txt_string(42,0,  "U:", MAKE_COLOR(SCREEN_COLOR, COLOR_WHITE));
             draw_txt_string(1, 1, "Values:",  MAKE_COLOR(SCREEN_COLOR, COLOR_WHITE));
             draw_txt_string(2, 2, "DWORD  :", MAKE_COLOR(SCREEN_COLOR, COLOR_WHITE));
             draw_txt_string(2, 3, "WORD   :", MAKE_COLOR(SCREEN_COLOR, COLOR_WHITE));
@@ -75,20 +120,39 @@
             draw_txt_string(2, 8, "DWORD  :", MAKE_COLOR(SCREEN_COLOR, COLOR_WHITE));
             draw_txt_string(2, 9, "WORD   :", MAKE_COLOR(SCREEN_COLOR, COLOR_WHITE));
             draw_txt_string(2, 10, "BYTE   :", MAKE_COLOR(SCREEN_COLOR, COLOR_WHITE));
+            draw_txt_string(2, 12, "STRING :", MAKE_COLOR(SCREEN_COLOR, COLOR_WHITE));
+#ifdef DEBUG_SHOW_DOUBLE
+            draw_txt_string(2, 5, "DOUBLE :", MAKE_COLOR(SCREEN_COLOR, COLOR_WHITE));
             draw_txt_string(2, 11, "DOUBLE :", MAKE_COLOR(SCREEN_COLOR, COLOR_WHITE));
-            draw_txt_string(2, 12, "STRING :", MAKE_COLOR(SCREEN_COLOR, COLOR_WHITE));
+#endif
 
-            debug_to_draw = 2;
+	    debug_to_draw = 2;
             break;
         case 2:
             sprintf(buf, "0x%08X", addr);
+	    buf[sinv] = 0;
             draw_txt_string(10, 0, buf, MAKE_COLOR(COLOR_BLACK, COLOR_WHITE));
+
+            sprintf(buf, "0x%08X", addr);
+	    buf[sinv+1] = 0;
+            draw_txt_string(10+sinv, 0, buf+sinv, MAKE_COLOR(COLOR_BLACK, COLOR_GREEN));
+
+            sprintf(buf, "0x%08X", addr);
+            draw_txt_string(10+sinv+1, 0, buf+sinv+1, MAKE_COLOR(COLOR_BLACK, COLOR_WHITE));
+
             sprintf(buf, "0x%08X", step);
-            draw_txt_string(28, 0, buf, MAKE_COLOR(COLOR_BLACK, COLOR_WHITE));
+            draw_txt_string(27, 0, buf, MAKE_COLOR(COLOR_BLACK, COLOR_WHITE));
+
+            sprintf(buf,"%0d",debug_auto_update);
+            draw_txt_string(40, 0, buf, MAKE_COLOR(COLOR_BLACK, COLOR_WHITE));
+
             sprintf(buf,"%0d",debug_cont_update);
             draw_txt_string(44, 0, buf, MAKE_COLOR(COLOR_BLACK, COLOR_WHITE));
             gui_debug_draw_values(2, addr);
-            gui_debug_draw_values(8, *((void**)addr));
+	    if ((addr<(void*)0x2000000 || addr>(void*)0xFFC00000))
+	    {
+		gui_debug_draw_values(8, *((void**)addr));
+	    }
             
             conf.mem_view_addr_init = (long)addr;
 
@@ -104,6 +168,11 @@
 void gui_debug_kbd_process() {
     switch (kbd_get_autoclicked_key()) {
     case KEY_DOWN:
+	debug_auto_update = !debug_auto_update;
+	if( debug_auto_update )
+	{
+	    debug_to_draw = 2;
+	}
         break;
     case KEY_UP:
 				debug_cont_update = !debug_cont_update;
@@ -118,6 +187,8 @@
         debug_to_draw = 2;
         break;
     case KEY_DISPLAY:
+	step_pos++;
+	step_pos %= 8;
         switch (step) {
             case 0x00000004: step = 0x00000010; break;
             case 0x10000000: step = 0x00000004; break;
@@ -127,17 +198,17 @@
         break;
     case KEY_ZOOM_IN: // reduce step
         switch (step) {
-            case 0x00000010: step = 0x0000004; break;
+            case 0x00000010: step = 0x0000004; step_pos = 0; break;
             case 0x00000004: break;
-            default: step>>=4; break;
+            default: step>>=4; step_pos--; break;
         }
 				debug_to_draw = 2;
 				break;
 		case KEY_ZOOM_OUT: // increase step
         switch (step) {
-            case 0x00000004: step = 0x00000010; break;
+            case 0x00000004: step = 0x00000010; step_pos = 1; break;
             case 0x10000000: break;
-            default: step<<=4; break;
+            default: step<<=4; step_pos++; break;
         }
 				debug_to_draw = 2;
 				break;
Index: core/makefile.inc.new
===================================================================
--- core/makefile.inc.new	(Revision 0)
+++ core/makefile.inc.new	(Revision 0)
@@ -0,0 +1,97 @@
+
+LOCAL_CFLAGS:=$(CTHUMB)
+
+# warning: library order matters!
+CORE_LDLIBS:= -lgcc
+CORE_LDOPTS=-nostdlib -Wl,--allow-shlib-undefined -Wl,-T,$(TOPDIR)/tools/link-boot.ld
+CORE_LDOPTS+=-Wl,-N,-Ttext,$(MEMISOSTART)
+
+OPT_OBJS:=
+ifdef OPT_GAME_REVERSI
+LOCAL_CFLAGS +=-DOPT_GAME_REVERSI
+OPT_OBJS+=gui_reversi.o
+endif
+ifdef OPT_GAME_SOKOBAN
+LOCAL_CFLAGS+=-DOPT_GAME_SOKOBAN
+OPT_OBJS+=gui_sokoban.o
+endif
+ifdef OPT_GAME_CONNECT4
+LOCAL_CFLAGS+=-DOPT_GAME_CONNECT4
+OPT_OBJS+=gui_4wins.o
+endif
+ifdef OPT_GAME_MASTERMIND
+LOCAL_CFLAGS+=-DOPT_GAME_MASTERMIND
+OPT_OBJS+=gui_mastermind.o
+endif
+ifdef OPT_CURVES
+LOCAL_CFLAGS+=-DOPT_CURVES
+OPT_OBJS+=curves.o
+endif
+ifdef OPT_TEXTREADER
+LOCAL_CFLAGS+=-DOPT_TEXTREADER
+OPT_OBJS+=gui_read.o 
+endif
+ifdef OPT_CALENDAR
+LOCAL_CFLAGS+=-DOPT_CALENDAR
+OPT_OBJS+=gui_calendar.o 
+endif
+ifdef OPT_DEBUGGING
+LOCAL_CFLAGS+=-DOPT_DEBUGGING
+OPT_OBJS+=gui_debug.o gui_bench.o 
+endif
+ifdef OPT_EDGEOVERLAY
+CFLAGS+=-DOPT_EDGEOVERLAY
+OPT_OBJS+=edgeoverlay.o 
+endif
+C_OBJS:= main.o gui_draw.o gui_menu.o gui_palette.o gui_mbox.o \
+     gui_fselect.o gui.o kbd.o conf.o \
+     histogram.o gui_batt.o gui_space.o gui_osd.o script.o raw.o \
+     gui_lang.o gui_mpopup.o gui_grid.o motion_detector.o raw_merge.o \
+     luascript.o shot_histogram.o dng.o $(OPT_OBJS)
+N_OBJS:= nothumb.o
+
+ASM_OBJS:=entry.o
+
+OBJS := $(call subdirize,$(ASM_OBJS) $(C_OBJS) $(N_OBJS) )
+N_OBJS:=$(call subdirize, $(N_OBJS) )
+C_OBJS:=$(call subdirize, $(C_OBJS) )
+ASM_OBJS:=$(call subdirize, $(ASM_OBJS) )
+
+MAIN_LIBS := \
+	$(TOPDIR)/platform/$(PLATFORM)/libplatform.a \
+	$(TOPDIR)/platform/$(PLATFORM)/sub/$(PLATFORMSUB)/libplatformsub.a \
+	$(TOPDIR)/lib/font/libfont.a \
+	$(TOPDIR)/lib/math/libmath.a \
+	$(TOPDIR)/lib/ubasic/libubasic.a \
+	$(TOPDIR)/lib/lang/liblang.a \
+	$(TOPDIR)/lib/lua/liblua.a
+
+core/nothumb.o:: core/nothumb.c
+	@echo $< \-\> $@
+	$(CC) $(CFLAGS) -marm -nostdinc -c -o $@ $<
+
+$(eval $(call compile-targets,$(C_OBJS),$(LOCAL_CFLAGS)))
+$(eval $(call compile-asm-targets,$(ASM_OBJS),$(LOCAL_CFLAGS)))
+
+$(eval $(call gen-rule, $(subdir)/main.bin, $(OBJS) $(subdir)/main.elf,  \
+	$(OBJDUMP) -z -d $(subdir)/main.elf > $(subdir)/main.dump; \
+	$(OBJCOPY) -O binary $(subdir)/main.elf $(subdir)/main.bin ))
+
+define postprocess-main-elf
+	( $(NM) $(subdir)/main.elf | grep ' U ' > $(subdir)/main.elf.syms ) && exit 1 || exit 0;
+	$(SIZE) $(subdir)/main.elf | tee $(TOPDIR)/size.txt;
+	$(SIZLENCE)printf " %s-%s (%s, #%s): MEMISOSIZE used: 0x%s\n" \
+	$(PLATFORM) $(PLATFORMSUB) $(PLATFORMOS) $(PLATFORMID) \
+	`cut -f5 $(TOPDIR)/size.txt | tail -1` >> $(TOPDIR)/bin/caminfo.txt;
+endef
+
+$(eval $(call gen-rule, $(subdir)/main.elf, $(OBJS) $(MAIN_LIBS), \
+    $(CC) $(CFLAGS) $(LOCAL_CFLAGS) -o $$@ --start-group $$^  $(CORE_LDLIBS) --end-group $(LDFLAGS) $(CORE_LDOPTS) || exit 1; \
+    $(call postprocess-main-elf) \
+    ))
+
+$(eval $(call gen-rule, core-clean,, rm -f $(OBJS) $(subdir)/*.$(DEPSUFFIX) $(subdir)/main.bin $(subdir)/main.elf $(subdir)/main.dump $(subdir)/main.elf.syms ))
+
+$(eval $(call gen-rule, core-distclean, core-clean, rm -f $(OBJS:.o=.d) ))
+
+# vim: filetype=make
Index: core/kbd.c
===================================================================
--- core/kbd.c	(Revision 727)
+++ core/kbd.c	(Arbeitskopie)
@@ -562,7 +562,7 @@
 // ------ modif by Masuji SUTO (start) --------------
 
 unsigned int mmode;
-unsigned int nCrzpos,i;
+int nCrzpos,i;
 unsigned int drmode = 0;
 
    if(conf.ricoh_ca1_mode && conf.remote_enable)
@@ -1344,7 +1344,7 @@
 
 int keyid_by_name (const char *n)
 {
-    int i;
+    unsigned i;
     for (i=0;i<sizeof(keynames)/sizeof(keynames[0]);i++)
 	if (strcmp(keynames[i].keyname,n) == 0)
 	    return keynames[i].keyid;
Index: core/gui_draw.c
===================================================================
--- core/gui_draw.c	(Revision 727)
+++ core/gui_draw.c	(Arbeitskopie)
@@ -71,7 +71,7 @@
      int error = 0;
      int y = y1;
      int ystep = (y1 < y2)?1:-1;
-     int x;
+     coord x;
      for (x=x1; x<=x2; ++x) {
          if (steep) draw_pixel(y, x, cl);
          else draw_pixel(x, y, cl);
@@ -298,7 +298,8 @@
 
 //-------------------------------------------------------------------
 void draw_ellipse(coord xc, coord yc, unsigned int a, unsigned int b, color cl) {
-    int x = 0, y = b;
+    unsigned int x = 0;
+    int y = b;
     long a2 = (long)a*a, b2 = (long)b*b;
     long crit1 = -((a2>>2) + (a&1) + b2);
     long crit2 = -((b2>>2) + (b&1) + a2);
@@ -315,7 +316,7 @@
             draw_pixel(xc+x, yc-y, cl);
             draw_pixel(xc-x, yc+y, cl);
         }
-        if (t + b2*x <= crit1 || t + a2*y <= crit3)
+        if ((long)(t + b2*x) <= crit1 || (long)(t + a2*y) <= crit3)
             ++x, dxt += d2xt, t += dxt;
         else if (t - a2*y > crit2)
             --y, dyt += d2yt, t += dyt;
@@ -328,7 +329,8 @@
 
 //-------------------------------------------------------------------
 void draw_filled_ellipse(coord xc, coord yc, unsigned int a, unsigned int b, color cl) {
-    int x = 0, y = b;
+    unsigned int x = 0;
+    int y = b;
     int rx = x, ry = y;
     unsigned int width = 1;
     unsigned int height = 1;
@@ -346,10 +348,10 @@
         draw_filled_rect(xc-a, yc, (a<<1)+1, 1, cl_fill);
     } else {
         while (y>=0 && x<=a) {
-            if (t + b2*x <= crit1 || t + a2*y <= crit3) {
+            if ((long)(t + b2*x) <= crit1 || (long)(t + a2*y) <= crit3) {
                 if (height == 1)
                     ; /* draw nothing */
-                else if (ry*2+1 > (height-1)*2) {
+                else if ((unsigned)(ry*2+1) > (height-1)*2) {
                     draw_filled_rect(xc-rx, yc-ry, xc-rx+width-1, yc-ry+(height-1)-1, cl_fill);
                     draw_filled_rect(xc-rx, yc+ry+1, xc-rx+width-1, yc+ry+1+(1-height)-1, cl_fill);
                     ry -= height-1;
@@ -369,7 +371,7 @@
                 height++;
             }
             else {
-                if (ry*2+1 > height*2) {
+                if ((unsigned)(ry*2+1) > height*2) {
                     draw_filled_rect(xc-rx, yc-ry, xc-rx+width-1, yc-ry+height-1, cl_fill);
                     draw_filled_rect(xc-rx, yc+ry+1, xc-rx+width-1, yc+ry+1-height-1, cl_fill);
                 }
@@ -385,7 +387,7 @@
             }
         }
 
-        if (ry > height) {
+        if ((unsigned)ry > height) {
             draw_filled_rect(xc-rx, yc-ry, xc-rx+width-1, yc-ry+height-1, cl_fill);
             draw_filled_rect(xc-rx, yc+ry+1, xc-rx+width-1, yc+ry+1-height-1, cl_fill);
         }
Index: core/gui_menu.c
===================================================================
--- core/gui_menu.c	(Revision 727)
+++ core/gui_menu.c	(Arbeitskopie)
@@ -31,7 +31,7 @@
 static int          gui_menu_top_item;
 static int          gui_menu_redraw;
 
-static int          count;
+static unsigned     count;
 static coord        x, y, w, num_lines;
 static int          len_bool, len_int, len_enum, len_space, len_br1, len_br2, cl_rect;
 static int          int_incr, incr_modified;
@@ -107,7 +107,7 @@
 				mod_user_menu(curr_menu->menu[gui_menu_curr_item],&gui_menu_curr_item, 1);
 			}
 			else {
-				int x;
+				unsigned int x;
 				/*
 				 * Remove entry from menu
 				 */
@@ -174,10 +174,12 @@
             for (j=0;j<c;++j){
             do {
                 if (curr_menu->menu[gui_menu_curr_item+1].text) {
-                    int i;
+                    unsigned int i;
                     for (i=0; i<num_lines-1 && curr_menu->menu[gui_menu_top_item+i].text; ++i);
-                    if (i==num_lines-1 && curr_menu->menu[gui_menu_top_item+i].text 
-                        && gui_menu_top_item+i-1==gui_menu_curr_item && curr_menu->menu[gui_menu_top_item+i+1].text)
+                    if (   i==num_lines-1 
+			&& curr_menu->menu[gui_menu_top_item+i].text 
+                        && (int)(gui_menu_top_item+i-1) == gui_menu_curr_item 
+			&& curr_menu->menu[gui_menu_top_item+i+1].text )
                         ++gui_menu_top_item;
                     ++gui_menu_curr_item;
                 } else {
@@ -485,7 +487,7 @@
 		if( (conf.user_menu_enable == 3)  && (curr_menu->title == LANG_MENU_USER_MENU)) {
 			mod_user_menu(curr_menu->menu[gui_menu_curr_item],&gui_menu_curr_item, 3);
 			gui_menu_redraw=1;
-			if(gui_menu_curr_item > gui_menu_top_item + num_lines -2) {
+			if(gui_menu_curr_item > (int)(gui_menu_top_item + num_lines -2) ) {
 				if((gui_menu_curr_item < USER_MENU_ITEMS) && curr_menu->menu[gui_menu_curr_item +1].text)
 					gui_menu_top_item++;
 			}
@@ -565,7 +567,8 @@
 //-------------------------------------------------------------------
 void gui_menu_draw() {
     static char tbuf[64];
-    int imenu, i, j, yy, xx, symbol_width;
+    unsigned i;
+    int imenu, j, yy, xx, symbol_width;
     color cl, cl_symbol;
     const char *ch = "";
 
Index: core/gui_osd.c
===================================================================
--- core/gui_osd.c	(Revision 727)
+++ core/gui_osd.c	(Arbeitskopie)
@@ -13,6 +13,7 @@
 #include "gui_space.h"
 #include "gui_grid.h"
 #include "gui_osd.h"
+#include "math.h"
 
 //-------------------------------------------------------------------
 typedef struct {
@@ -49,7 +50,7 @@
 static char osd_buf3[10];
 static char osd_buf4[10];
 
-static int step;
+static unsigned step;
 
 // Width (in pixels) of half-shoot Canon OSD area of the screen buffer, for restore during 
 // Zebra draw, to limit RAM usage of zebra. Only these border areas are stored in RAM.
@@ -124,7 +125,7 @@
         break;
     case KEY_RIGHT:
         if (osd[curr_item].pos->x < screen_width-osd[curr_item].size.x) {
-            osd[curr_item].pos->x+=(screen_width-osd[curr_item].size.x-osd[curr_item].pos->x>step)?step:screen_width-osd[curr_item].size.x-osd[curr_item].pos->x;
+            osd[curr_item].pos->x+=(screen_width-osd[curr_item].size.x-osd[curr_item].pos->x > step)?step:screen_width-osd[curr_item].size.x-osd[curr_item].pos->x;
             osd_to_draw = 1;
         } else
             osd[curr_item].pos->x = screen_width-osd[curr_item].size.x;
@@ -337,7 +338,8 @@
 
 //-------------------------------------------------------------------
 int gui_osd_draw_zebra(int show) {
-    unsigned int v, s, x, y, f, over;
+    int y, over;
+    unsigned int v, s, x, f;
     color cl_under=conf.zebra_color>>8, cl_over=conf.zebra_color&0xFF;
     static int need_restore=0;
     int viewport_height;
Index: core/gui_grid.c
===================================================================
--- core/gui_grid.c	(Revision 727)
+++ core/gui_grid.c	(Arbeitskopie)
@@ -52,7 +52,7 @@
 //-------------------------------------------------------------------
 static void process_title(const char *title) {
     register const char *ptr = title;
-    register int i=0;
+    register unsigned int i=0;
 
     while (ptr[0]==' ' || ptr[0]=='\t') ++ptr; // whitespaces
     while (i<(sizeof(grid_title)-1) && ptr[i] && ptr[i]!='\r' && ptr[i]!='\n') {
@@ -63,10 +63,10 @@
 }
 
 //-------------------------------------------------------------------
-static void process_element(const char *str, int n, grid_elem_type type) {
+static void process_element(const char *str, unsigned int n, grid_elem_type type) {
     register const char *ptr = str;
     char *nptr;
-    register int i;
+    register unsigned int i;
     long nums[6];
     struct gline  *gptr;
 
Index: core/gui_fselect.c
===================================================================
--- core/gui_fselect.c	(Revision 727)
+++ core/gui_fselect.c	(Arbeitskopie)
@@ -116,7 +116,7 @@
     struct dirent *de;
     static struct stat   st;
     struct fitem  **ptr = &head, *prev = NULL;
-    int    i;
+    unsigned int    i;
 
     gui_fselect_free_data();
 
@@ -239,7 +239,8 @@
 
 //-------------------------------------------------------------------
 void gui_fselect_draw() {
-    int i, j, off_name_x, off_size_x, off_time_x, off_body_x, off_body_y;
+    unsigned i;
+    int j, off_name_x, off_size_x, off_time_x, off_body_x, off_body_y;
     struct fitem  *ptr;
     char buf[100];
     struct tm *time;
@@ -808,7 +809,7 @@
     for (ptr=head; ptr; ptr=ptr->next) {
         if (ptr->marked && ptr->attr != 0xFF && 
             !(ptr->attr & DOS_ATTR_DIRECTORY) &&
-            ptr->size == hook_raw_size() &&
+            (long)ptr->size == hook_raw_size() &&
             (strcmp(ptr->name,selected->name)) != 0) {
             sprintf(raw_subtract_from,"%s/%s",current_dir,ptr->name);
             sprintf(raw_subtract_dest,"%s/%s%s",current_dir,img_prefixes[conf.sub_batch_prefix],ptr->name+4);
@@ -831,7 +832,7 @@
     int i;
     char *p = buf + sprintf(buf,"%s %s\n",selected->name,lang_str(LANG_FSELECT_SUB_FROM));
     for (ptr=head, i=0; ptr; ptr=ptr->next) {
-        if (ptr->marked && ptr->attr != 0xFF && !(ptr->attr & DOS_ATTR_DIRECTORY) && ptr->size == hook_raw_size()) {
+        if (ptr->marked && ptr->attr != 0xFF && !(ptr->attr & DOS_ATTR_DIRECTORY) && (long)ptr->size == hook_raw_size()) {
             if ( i < MAX_SUB_NAMES ) {
                 sprintf(p, "%s\n",ptr->name);
                 // keep a pointer to the one before the end, so we can stick ...and more on
@@ -1011,7 +1012,7 @@
                      (selected->name[0] == 'D' && selected->name[1] == 'C' && selected->name[2] == 'I' && selected->name[3] == 'M') ||//If item is DCIM folder
                      (selected->name[3] == 'C'))//If item is a DCIM sub folder
                     i |= MPOPUP_PURGE;//Display PURGE RAW function in popup menu
-                if(selected->size == hook_raw_size())
+                if((long)selected->size == hook_raw_size())
                     i |= MPOPUP_RAW_DEVELOP;
 #if DNG_SUPPORT
                 if((fselect_marked_count()>1)||(selected->size > hook_raw_size()))
Index: core/gui_batt.c
===================================================================
--- core/gui_batt.c	(Revision 727)
+++ core/gui_batt.c	(Arbeitskopie)
@@ -27,7 +27,7 @@
 
 //-------------------------------------------------------------------
 unsigned long get_batt_perc() {
-    unsigned long v;
+    long v;
 
     v = get_batt_average();
     if (v>conf.batt_volts_max) v=conf.batt_volts_max;
@@ -37,7 +37,7 @@
 
 //-------------------------------------------------------------------
 static void gui_batt_draw_icon () {
-    coord x;
+    int x;
     int perc = get_batt_perc();
     color cl = (perc<=10)?conf.osd_color_warn:(conf.batt_icon_color&0xFF);
 
Index: core/luascript.c
===================================================================
--- core/luascript.c	(Revision 727)
+++ core/luascript.c	(Arbeitskopie)
@@ -229,7 +229,7 @@
   unsigned id = luaL_checknumber( L, 1 );
   unsigned val;
 
-  if (id >= get_flash_params_count()) {
+  if (id >= (unsigned)get_flash_params_count()) {
     // return nil
     return 0;
   }
Index: core/gui_mastermind.c
===================================================================
--- core/gui_mastermind.c	(Revision 727)
+++ core/gui_mastermind.c	(Arbeitskopie)
@@ -100,8 +100,8 @@
 	colors[1]=0x55;
 	colors[2]=0x22;
 	colors[3]=0x66;
-	colors[4]=0x88;
-	colors[5]=0xD2;
+	colors[4]=0x99;
+	colors[5]=0x2F;
 	curr_color[0]=0;
 	curr_color[1]=0;
 	curr_color[2]=0;
Index: core/gui_mbox.c
===================================================================
--- core/gui_mbox.c	(Revision 727)
+++ core/gui_mbox.c	(Arbeitskopie)
@@ -38,7 +38,7 @@
 
 //-------------------------------------------------------------------
 void gui_mbox_init(int title, int msg, const unsigned int flags, void (*on_select)(unsigned int btn)) {
-    int i;
+    unsigned int i;
 
     mbox_buttons_num = 0;
     for (i=0; i<BUTTONSNUM && mbox_buttons_num<MAX_BUTTONS; ++i) {
Index: core/gui_calendar.c
===================================================================
--- core/gui_calendar.c	(Revision 727)
+++ core/gui_calendar.c	(Arbeitskopie)
@@ -123,7 +123,7 @@
 
 //-------------------------------------------------------------------
 void gui_calendar_draw() {
-    int x, y;
+    unsigned int x, y;
     static char str[32];
     int w, d, i;
     unsigned long t;
@@ -152,7 +152,7 @@
         y += FONT_HEIGHT+4+4;
 
         y += FONT_HEIGHT+4;
-        for (x=0; x<w; ++x) {
+        for (x=0; x<(unsigned)w; ++x) {
             draw_string(cal_x+x*FONT_WIDTH*4, y, "    ", (x<5)?CALENDAR_COLOR:WEEKEND_COLOR);
         }
         
Index: core/main.c
===================================================================
--- core/main.c	(Revision 727)
+++ core/main.c	(Arbeitskopie)
@@ -68,6 +68,22 @@
         spytask_can_start = 1;
 }
 
+#include "gui.h"
+#include "gui_draw.h"
+
+void brain_dump() 
+{
+    char buf[64];
+    static const int p = 20;
+    static const long a = 4;
+    static int v = 0;
+
+    get_parameter_data(p,&v,a);
+
+    sprintf(buf,"param %d is %d",p,v);
+    draw_string(16,0,buf,MAKE_COLOR(COLOR_BLACK,COLOR_YELLOW));
+}
+
 void core_spytask()
 {
     int cnt = 1;
@@ -106,6 +122,7 @@
 #ifdef OPT_EDGEOVERLAY
     mkdir("A/CHDK/EDGE");
 #endif
+
     auto_started = 0;
 
     if (conf.script_startup==1) script_autostart();				// remote autostart
@@ -133,6 +150,8 @@
 #endif
 	}
 
+//	brain_dump();
+
 	if ((state_shooting_progress == SHOOTING_PROGRESS_PROCESSING) && (!shooting_in_progress())) {
 	    state_shooting_progress = SHOOTING_PROGRESS_DONE;
             if (raw_need_postprocess) raw_postprocess();
Index: core/histogram.c
===================================================================
--- core/histogram.c	(Revision 727)
+++ core/histogram.c	(Arbeitskopie)
@@ -17,7 +17,7 @@
 
 
 unsigned char histogram[5][HISTO_WIDTH];                    // RGBYG
-long exposition_thresh;
+unsigned long exposition_thresh;
 long under_exposed;
 long over_exposed;
 long histo_magnification;
Index: version.inc
===================================================================
--- version.inc	(Revision 727)
+++ version.inc	(Arbeitskopie)
@@ -1 +1 @@
-BUILD_NUMBER := 0.9.7
+BUILD_NUMBER := 0.9.7-p0
Index: tools/packfi2/makefile.inc.new
===================================================================
--- tools/packfi2/makefile.inc.new	(Revision 0)
+++ tools/packfi2/makefile.inc.new	(Revision 0)
@@ -0,0 +1,27 @@
+
+
+OBJS:=fi2enc.o aes128.o compress.o deflate.o crc32.o zutil.o adler32.o trees.o
+OBJS:=$(call subdirize,$(OBJS))
+
+
+%.o: %.c
+	@echo $< \-\> $@
+	$(HOSTCC) $(HOSTCFLAGS) -DPLATFORMOS_$(PLATFORMOS) -c -o $@ $<
+
+.dep/%.d: %.c .dep
+	$(HOSTCC) $(HOSTCFLAGS) -MM $< > $@.$$$$; \
+	    sed 's,\($*\)\.o[ :]*,\1.o $@ : ,g' < $@.$$$$ > $@; \
+	    rm -f $@.$$$$
+
+fi2enc$(EXE): $(OBJS)
+	@echo $< \-\> $@
+	$(HOSTCC) $(HOSTCFLAGS) -o $@ $^
+
+clean:
+	rm -f fi2enc$(EXE) $(OBJS)
+
+distclean: clean
+
+include $(topdir)bottom.inc
+
+# vim: filetype=make
Index: tools/makefile.inc.new
===================================================================
--- tools/makefile.inc.new	(Revision 0)
+++ tools/makefile.inc.new	(Revision 0)
@@ -0,0 +1,59 @@
+
+LOCAL_SUBDIRS := packfi2
+LOCAL_SUBDIRS:=$(call subdirize,$(LOCAL_SUBDIRS) )
+$(foreach subdir,$(LOCAL_SUBDIRS),$(eval include $(subdir)/makefile.inc.new) )
+
+OBJS:=pakwif.o finsig.o gensig.o dumpchk.o dancingbits.o
+OBJS:=$(call subdirize,$(OBJS))
+
+$(eval $(call compile-host-targets, $(OBJS), -DPLATFORMOS_$(PLATFORMOS) ) )
+
+$(eval $(call gen-rule, $(subdir)/pakwif$(EXE), $(subdir)/pakwif.o, $(HOSTCC) $(HOSTCFLAGS) -o $$@ $$^ ))
+$(eval $(call gen-rule, $(subdir)/finsig$(EXE), $(subdir)/finsig.o, $(HOSTCC) $(HOSTCFLAGS) -o $$@ $$^ ))
+$(eval $(call gen-rule, $(subdir)/gensig$(EXE), $(subdir)/gensig.o, $(HOSTCC) $(HOSTCFLAGS) -o $$@ $$^ ))
+$(eval $(call gen-rule, $(subdir)/dancingbits$(EXE), $(subdir)/dancingbits.o, $(HOSTCC) $(HOSTCFLAGS) -o $$@ $$^ ))
+$(eval $(call gen-rule, $(subdir)/dumpchk$(EXE), $(subdir)/dumpchk.o, $(HOSTCC) $(HOSTCFLAGS) -o $$@ $$^ ))
+
+$(eval $(call gen-rule,tools-clean,,rm -f $(subdir)/*.HOST.d ))
+$(eval $(call gen-rule,tools-distclean, tools-clean ,rm -f $(subdir)/*.HOST.d $(subdir)/pakwif$(EXE) $(subdir)/finsig$(EXE) $(subdir)/gensig$(EXE) $(OBJS)))
+#	if [ -s sig_ref_vxworks_1.bin ] && [ -s sig_ref_vxworks_2.bin ] && [ -s sig_ref_vxworks_3.bin ] ; then \
+#	  rm -f signatures_vxworks.h ; \
+#	fi
+#	if [ -s sig_ref_dryos_1.bin ] ; then \
+#	  rm -f signatures_dryos.h ; \
+#	fi
+
+#	rm -f signatures.h
+
+
+tools/signatures_vxworks.h: tools/gensig$(EXE) tools/gensigs.sh tools/sig_ref_vxworks_1.txt tools/sig_ref_vxworks_1.bin tools/sig_ref_vxworks_2.txt tools/sig_ref_vxworks_2.bin tools/sig_ref_vxworks_3.txt tools/sig_ref_vxworks_3.bin
+	@echo \-\> $@
+	if [ -s tools/sig_ref_vxworks_1.bin ] && [ -s tools/sig_ref_vxworks_2.bin ] && [ -s tools/sig_ref_vxworks_3.bin ] ; then \
+	  $(SH) tools/gensigs.sh $(SORT) vxworks "1 2 3" > tools/signatures_vxworks.h ; \
+	else \
+	  echo CAUTION! \'signatures_vxworks.h\' is not uptated due to \'sig_ref_vxworks_1.bin\` or \'sig_ref_vxworks_2.bin\` or \'sig_ref_vxworks_3.bin\` is empty! ; \
+	  touch tools/signatures_vxworks.h ; \
+	fi
+
+tools/signatures_dryos.h: tools/gensig$(EXE) tools/gensigs.sh tools/sig_ref_dryos_1.txt tools/sig_ref_dryos_1.bin
+	@echo \-\> $@
+	if [ -s tools/sig_ref_dryos_1.bin ] ; then \
+	  $(SH) tools/gensigs.sh $(SORT) dryos "1" > tools/signatures_dryos.h ; \
+	else \
+	  echo CAUTION! \'signatures_dryos.h\' is not uptated due to \'sig_ref_dryos_1.bin\` is empty! ; \
+	  touch tools/signatures_dryos.h ; \
+	fi
+
+tools/sig_ref_vxworks_1.bin:
+	touch tools/sig_ref_vxworks_1.bin
+
+tools/sig_ref_vxworks_2.bin:
+	touch tools/sig_ref_vxworks_2.bin
+
+tools/sig_ref_vxworks_3.bin:
+	touch tools/sig_ref_vxworks_3.bin
+
+tools/sig_ref_dryos_1.bin:
+	touch tools/sig_ref_dryos_1.bin
+
+# vim: filetype=make
Index: loader/g9/resetcode/makefile.inc.new
===================================================================
--- loader/g9/resetcode/makefile.inc.new	(Revision 0)
+++ loader/g9/resetcode/makefile.inc.new	(Revision 0)
@@ -0,0 +1,6 @@
+
+# warning: library order matters!
+
+include $(TOPDIR)/loader/makefile_resetcode.inc.new
+
+# vim: ft=make
Index: loader/g9/makefile.inc.new
===================================================================
--- loader/g9/makefile.inc.new	(Revision 0)
+++ loader/g9/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/loader/makefile_generic.inc.new
+
+# vim: ft=make
Index: loader/s2is/resetcode/makefile.inc.new
===================================================================
--- loader/s2is/resetcode/makefile.inc.new	(Revision 0)
+++ loader/s2is/resetcode/makefile.inc.new	(Revision 0)
@@ -0,0 +1,6 @@
+
+# warning: library order matters!
+
+include $(TOPDIR)/loader/makefile_resetcode.inc.new
+
+# vim: ft=make
Index: loader/s2is/makefile.inc.new
===================================================================
--- loader/s2is/makefile.inc.new	(Revision 0)
+++ loader/s2is/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/loader/makefile_generic.inc.new
+
+# vim: ft=make
Index: loader/s3is/resetcode/makefile.inc.new
===================================================================
--- loader/s3is/resetcode/makefile.inc.new	(Revision 0)
+++ loader/s3is/resetcode/makefile.inc.new	(Revision 0)
@@ -0,0 +1,6 @@
+
+# warning: library order matters!
+
+include $(TOPDIR)/loader/makefile_resetcode.inc.new
+
+# vim: ft=make
Index: loader/s3is/makefile.inc.new
===================================================================
--- loader/s3is/makefile.inc.new	(Revision 0)
+++ loader/s3is/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/loader/makefile_generic.inc.new
+
+# vim: ft=make
Index: loader/ixus65_sd630/resetcode/makefile.inc.new
===================================================================
--- loader/ixus65_sd630/resetcode/makefile.inc.new	(Revision 0)
+++ loader/ixus65_sd630/resetcode/makefile.inc.new	(Revision 0)
@@ -0,0 +1,6 @@
+
+# warning: library order matters!
+
+include $(TOPDIR)/loader/makefile_resetcode.inc.new
+
+# vim: ft=make
